#ifndef DM_CQPARSE_H
#define DM_CQPARSE_H

/*
 * Projekt: C-quest
 * Autor: David Martinek (c) 2004
 * email: martinek@fit.vutbr.cz
 * Licence: GPL v.2
 * Popis: Modul s funkcemi pro analzu a natn vstupnho souboru.
 *  
 * $Id: cqparse.h,v 1.8 2004/07/12 17:30:44 martinek Exp $
 * 
 * Copyright (C)2004 David Martinek
 *
 * Tento program je svobodn software; mete jej it a modifikovat podle
 * ustanoven GNU General Public License, vydvan Free Software
 * Foundation; a to bu verze 2 tto licence anebo (podle vaeho uven)
 * kterkoli pozdj verze.
 *
 * Tento program je roziovn v nadji, e bude uiten, avak BEZ
 * JAKKOLI ZRUKY; neposkytuj se ani odvozen zruky PRODEJNOSTI anebo
 * VHODNOSTI PRO URIT EL. Dal podrobnosti hledejte ve GNU General Public 
 * License.
 *
 * Kopii GNU General Public License jste ml obdret spolu s tmto
 * programem; pokud se tak nestalo, napite o ni Free Software Foundation,
 * Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include <stdbool.h>
#include "cqlist.h"

/** Znak oznaujc koment. V tto implementaci jde o znak mka (#) */
extern const char C_COMM;

/** Znak oznaujc oddlova poloek v souboru. Jde o znak hvzdika (*). */
extern const char C_STAR;

/** Chybov hlka udvajc, e ve je v podku. */
extern const char *NOERR;

/** Varovn, e v souboru jsou pli dlouh dky. */
extern const char *WARN_LONGLINE;

/** Chyb nadpis testu. */
extern const char *ERR_TITLE;

/** Chyba nkde v otzce. */
extern const char *ERR_QUEST;

/** Chyba nkde ve variantch odpovd. */
extern const char *ERR_VAR;

/** Chybn poad variant odpovd. */
extern const char *ERR_VARORDER;

/** Chyba na dku se sprvnou odpovd a asem. */
extern const char *ERR_ANSWTIME;

/** Chyba nkde v textu s vysvtlenm sprvn odpovdi. */
extern const char *ERR_EXPL;

/** Chyb oddlova (hvzdika) v mst, kde byl oekvn.  */
extern const char *ERR_SEP;

/** Neoekvan konec souboru. */
extern const char *ERR_EOF;

/** Chyba na dku ... */
extern const char *ERR_ONLINE;

/**
 * Struktura oznaujc chybu a slo dku, na kterm dolo k chyb.
 * Tato struktura je vracena funkc readTest.
 *
 *
 * Sloku errMsg je mon porovnvat s nkterou z konstant ERR_ .
 */
typedef struct error_code
{
  const char *errMsg; /**< Chybov hlka pro specifikaci chyby pi analze 
                        souboru. */
  int line;           /**< slo dku, na kterm dolo k chyb. */
} TErrorCode;

/**
 * Nate data ze souboru. Vrac true, pokud ve probhlo bez problm nebo
 * vrac false, pokud je soubor ve patnm formtu.
 *
 * @return Vrac strukturu chybovou zprvou a s slem dku, kde tato chyba
 *   vznikla. Pokud je chybov zprva NOERR, k dn chyb nedolo a ve
 *   sloce .line je poet dk souboru (me se liit o jedniku od 
 *   skutenosti - zle na tom, jestli konec dku le na konci nebo na
 *   zatku dku).
 */
TErrorCode readTest(FILE *f, TTestData *data);

#endif

