/*
 * Projekt: C-quest
 * Autor: David Martinek (c) 2004
 * email: martinek@fit.vutbr.cz
 * Licence: GPL v.2
 * Popis: Modul s pomocnmi funkcemi.
 *  
 * $Id: cqtools.c,v 1.5 2004/07/12 17:30:44 martinek Exp $
 * 
 * Copyright (C)2004 David Martinek
 *
 * Tento program je svobodn software; mete jej it a modifikovat podle
 * ustanoven GNU General Public License, vydvan Free Software
 * Foundation; a to bu verze 2 tto licence anebo (podle vaeho uven)
 * kterkoli pozdj verze.
 *
 * Tento program je roziovn v nadji, e bude uiten, avak BEZ
 * JAKKOLI ZRUKY; neposkytuj se ani odvozen zruky PRODEJNOSTI anebo
 * VHODNOSTI PRO URIT EL. Dal podrobnosti hledejte ve GNU General Public 
 * License.
 *
 * Kopii GNU General Public License jste ml obdret spolu s tmto
 * programem; pokud se tak nestalo, napite o ni Free Software Foundation,
 * Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "cqtools.h"
#include "cqhelp.h"
#include <stdio.h>
#include <string.h>

/**
 * Provede alokaci pamti a v ppad, e dojde k chyb se vype chybov
 * hlen a program se ukon.
 *
 * !Pi chyb neuvoluji vekerou dosud alokovanou pam! To by bylo pli
 * sloit (v C neexistuj vjimky). Tohle je velmi vjimen udlost, take si
 * dovolm spolhat na to, e operan systm se s tm vyrovn. Pokud toho
 * nen schopen, tak by stejn v nejbli dob sletl a nem cenu si s tm
 * dlat njakou ke... 
 */
void *myAlloc(size_t size)
{
  void *ptr = malloc(size);
  if (ptr == NULL)
  {
    printError(NO_MEMORY);
    exit(2);
  }
  return ptr;
}

/**
 * Vytvo duplikt zadanho etzce. Tato funkce alokuje pam. V ppad, e
 * dojde k chyb, vype chybov hlen a ukon program.
 */
char *myStrdup(const char *s)
{
  char *ptr = myAlloc(strlen(s)+1);
  strcpy(ptr, s);
  return ptr; 
}

